#include "Signature.h"
#include<stdlib.h>
#include <iostream>
#include <fstream>
using namespace std;


class heapNode
{
public:
int cost,time;
int destVertex;
int predVertex;
heapNode()
{
cost=0;
time=0;
destVertex=0;
}

int operator <(heapNode h)
{
	if(cost<h.cost) return 1;
	else if((cost==h.cost)&&(time<h.time)) return 1;
	else return 0;
	
}

void operator=(heapNode h)
{
	cost=h.cost;
	time=h.time;
	destVertex=h.destVertex;
	predVertex=h.predVertex;
}
};

Signature **sign;
pathSignature **S;
int *scount,mainsrc,budgetcost,budgettime;
int no_of_vertices;
void minHeapify(heapNode *h, int i,int arraySize);
void buildHeap(heapNode *h,int arraySize);
void resize(heapNode *a, int &arraySize);
void getPath(int);
void readFile(char *filename);
int isEmpty(heapNode *h, int arraySize);

heapNode extractMin(heapNode *a,int arraySize);


int main(int argc, char *argv[])
{
int src,dv,i;
int des;
heapNode tempsrc;
tempsrc.destVertex=10;
readFile(argv[1]);
S=new pathSignature*[no_of_vertices];
for(i=0;i<no_of_vertices;i++)
	S[i]= new pathSignature[100];

scount= new int[no_of_vertices];
int *initarray=new int[no_of_vertices];

for(i=0;i<no_of_vertices;i++)
{scount[i]=0;initarray[i]=1;}

//cout<<"\n"<<"Enter source Vertex::";cin>>tempsrc.destVertex;
tempsrc.destVertex=atoi(argv[2]);
des=atoi(argv[3]);
if(tempsrc.destVertex>no_of_vertices) {cout<<"\nNo such vertex";exit(0);}
//cout<<"\n"<<"Enter destination Vertex::";cin>>des;

if(des>no_of_vertices) {cout<<"\nNo such vertex";exit(0);}
//cout<<"\n"<<"Enter Cost budget::";cin>>budgetcost;
budgetcost=atoi(argv[4]);


int count=0,arraySize=0;
int init=1;

heapNode *heapNodeArray=new heapNode[50];
int loopcnt=0;

do	
{

src=tempsrc.destVertex;

loopcnt++;

	if (init==1) {init=0; mainsrc=src;}
for(i=0;i<no_of_vertices;i++)
{
  if(count>arraySize)  
   {
   cerr<<"Resize occurs here";
   resize(heapNodeArray,arraySize);
   }


    if( (sign[src][i].cost <500) )
	{
             
	
		heapNodeArray[count].cost=sign[src][i].cost+tempsrc.cost;
	    heapNodeArray[count].time=sign[src][i].time+tempsrc.time;
	    heapNodeArray[count].destVertex=i;
		heapNodeArray[count].predVertex=src;
        count++;arraySize++;
	}
}//for	


   buildHeap(heapNodeArray,arraySize);
       
   heapNode temp=extractMin(heapNodeArray,arraySize);

   count--;arraySize--;

   dv=temp.destVertex;  
   char srcstr[2];

   	if(initarray[dv] ==1)
	{
		initarray[dv]=0;
   	   S[dv][scount[dv]].cost=temp.cost;
	   S[dv][scount[dv]].time=temp.time;
	   S[dv][scount[dv]].predVertex=temp.predVertex;
	   scount[dv]++;
	}
    else  
	{	
		if( (temp.time) <=S[dv][scount[dv]-1].time)
		{		
   	   S[dv][scount[dv]].cost=temp.cost;
	   S[dv][scount[dv]].time=temp.time;
	   S[dv][scount[dv]].predVertex=temp.predVertex;
	   scount[dv]++;
		}

	}
	 
   
    tempsrc=temp;
  

	

	//int ip;cin>>ip;

}while(loopcnt<=(no_of_vertices*no_of_vertices));

for(i=0;i<no_of_vertices;i++)
	{
    if(i==mainsrc) continue;
	cout<<"S["<<i<<"]"<<"\n";
	for(int j=0;j<scount[i];j++)
	{
	cout<<S[i][j].cost<<"  "<<S[i][j].time<<"  "<<S[i][j].predVertex<<"\n";
	}
	}


cout<<"\n\nPath\n\n";
char pth[100];
strcpy(pth," ");
getPath(des);
return 0;	
}


int isEmpty(heapNode *h,int arraySize)
{
	int retval=0;
	for (int i=0;i<arraySize;i++)
	 {
	if( (h[i].cost>500) || (h[i].time>500) )
		retval=1;
	}
	return retval;
}

void getPath(int des)
{
	if(scount[des]==0) {cerr<<"\nNo path exists between src and dest\n";exit(0); }
	int bc=budgetcost;
	
        int cst=0,tim=0,fl=1;
	while(des!=mainsrc)
	{
	
	int mintime=1000,minpred=-1;
	
	for(int i=0;i<scount[des];i++)
	{
		if(S[des][i].cost<=bc) {if(S[des][i].time<mintime) minpred=i;}
	}
	if(minpred==-1) {cerr<<"\nNo path exists between src and dest within the budgetted cost\n";exit(0); }
	cerr<<des<<"<-";
	if(fl==1)
	{
	cst=S[des][minpred].cost;tim=S[des][minpred].time;
	fl=0;
	}
	int newdes=S[des][minpred].predVertex;
	
	bc-=sign[newdes][des].cost;
	des=newdes;
	
	}
	cerr<<des<<"\n";
	cerr<<"\nTotal Cost="<<cst<<"  "<<"Total time="<<tim<<"\n";
}



void resize(heapNode *hn,int& arraySize)
{
arraySize=arraySize*2;
heapNode *b=new heapNode[arraySize];
for(int i=0;i <=arraySize/2;i++)
{
 b[i].cost=hn[i].cost;
 b[i].time=hn[i].time;
 b[i].destVertex=hn[i].destVertex;
}
hn=b;
}


void buildHeap(heapNode *hn,int arraySize)
{
for(int i=((arraySize)/2)+1;i>=0;i--)
 {
  minHeapify(hn,i,arraySize);
 }
}

void minHeapify(heapNode *hn, int pos,int arraySize)
{
int smallest;

int l=((pos+1)*2)-1;

int r=((pos+1)*2 );


if( (l<arraySize) && (hn[l]<hn[pos]) )
{


smallest=l;

}
else
{
smallest=pos;
}
if( (r<arraySize) && (hn[r]<hn[smallest]) )
{
smallest=r;
}
if(smallest != pos)
{
heapNode temp=hn[pos];
hn[pos]=hn[smallest];
hn[smallest]=temp;

minHeapify(hn,smallest,arraySize);
}
}


heapNode extractMin(heapNode *hn,int arraySize)
{

heapNode temp=hn[0];
for(int i=0;i<arraySize -1;i++)
	hn[i]=hn[i+1];
hn[arraySize].cost=1000;
hn[arraySize].time=1000;
buildHeap(hn,arraySize-1);
return temp;

}



void readFile(char *filename)
{
	fstream f;
	f.open(filename,ios::in);
	if(!f.is_open()) {cerr<<"File does not exist\n";exit(0);}
	
	f>>no_of_vertices;
	int linecount=0,count=0;
	 sign=new Signature*[no_of_vertices];

    for(int i=0;i<no_of_vertices;i++)
		sign[i]= new Signature[no_of_vertices];


	char *tempstr=new char[10];

	while(!(f.eof()))
	{
		f>>tempstr;
		linecount++;
	}
	f.clear();f.seekg(0);
	f>>no_of_vertices;
  

	int tempsrc=-1,tempdest=-1;
	char comma=',';
	do
	{
		f>>tempsrc>>comma>>tempdest;
		f>>comma>>sign[tempsrc][tempdest].cost>>comma>>sign[tempsrc][tempdest].time;
		count++;
	}while(count <=linecount);
	
	
	f.close();
}
